chiark / gitweb /
run-tests: verbose output for `fdroid update` to aid debugging
[fdroidserver.git] / tests / run-tests
index 7891e3c9a79aedb6d3267d359238728bcbf13dd9..c770091f2339583932a3702d550c5727fa250d34 100755 (executable)
@@ -1,11 +1,9 @@
 #!/bin/bash
 
 set -e # quit script on error
-set -x # show each command as it is executed
 
 echo_header() {
-    echo "=============================================================================="
-    echo $1
+    { echo -e "==============================================================================\n$1"; } 2>/dev/null
 }
 
 copy_apks_into_repo() {
@@ -58,6 +56,10 @@ if [ -z "$ANDROID_HOME" ]; then
     exit 1
 fi
 
+if [ -d tests ]; then
+    cd tests
+fi
+
 if [ -z "$1" ]; then
     APKDIR=`pwd`
 else
@@ -84,6 +86,7 @@ if [ -z $python ]; then
     python=python2
 fi
 
+set -x # show each command as it is executed
 
 #------------------------------------------------------------------------------#
 echo_header "run commit hooks"
@@ -102,6 +105,12 @@ for testcase in $WORKSPACE/tests/*.TestCase; do
 done
 
 
+#------------------------------------------------------------------------------#
+echo_header "print fdroid version"
+
+$fdroid --version
+
+
 #------------------------------------------------------------------------------#
 echo_header "build the TeX manual"
 
@@ -109,6 +118,44 @@ cd $WORKSPACE/docs
 ./gendocs.sh -o html --email admin@f-droid.org fdroid "F-Droid Server Manual"
 
 
+#------------------------------------------------------------------------------#
+echo_header "test metadata checks"
+
+REPOROOT=`create_test_dir`
+cd $REPOROOT
+
+touch config.py
+mkdir repo
+cp $WORKSPACE/tests/urzip.apk $REPOROOT/repo/
+
+set +e
+$fdroid build
+if [ $? -eq 0 ]; then
+    echo "This should have failed because there is no metadata!"
+    exit 1
+else
+    echo "testing metadata checks passed"
+fi
+set -e
+
+mkdir $REPOROOT/metadata/
+cp $WORKSPACE/tests/metadata/org.smssecure.smssecure.txt $REPOROOT/metadata/
+$fdroid readmeta
+
+# now make a fake duplicate
+touch $REPOROOT/metadata/org.smssecure.smssecure.yaml
+
+set +e
+$fdroid readmeta
+if [ $? -eq 0 ]; then
+    echo "This should have failed because there is a duplicate metadata file!"
+    exit 1
+else
+    echo "testing duplicate metadata checks passed"
+fi
+set -e
+
+
 #------------------------------------------------------------------------------#
 echo_header "create a source tarball and use that to build a repo"
 
@@ -121,7 +168,7 @@ tar xzf `ls -1 $WORKSPACE/dist/fdroidserver-*.tar.gz | sort -n | tail -1`
 cd $REPOROOT
 ./fdroidserver-*/fdroid init
 copy_apks_into_repo $REPOROOT
-./fdroidserver-*/fdroid update --create-metadata
+./fdroidserver-*/fdroid update --create-metadata --verbose
 
 
 #------------------------------------------------------------------------------#
@@ -130,7 +177,7 @@ echo_header "test config checks of local_copy_dir"
 REPOROOT=`create_test_dir`
 cd $REPOROOT
 $fdroid init
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 $fdroid server update --local-copy-dir=/tmp/fdroid
 
@@ -167,7 +214,7 @@ REPOROOT=`create_test_dir`
 cd $REPOROOT
 $fdroid init
 copy_apks_into_repo $REPOROOT
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 grep -F '<application id=' repo/index.xml > /dev/null
 
@@ -271,7 +318,7 @@ cd $REPOROOT
 $fdroid init --keystore $KEYSTORE --android-home $STORED_ANDROID_HOME --no-prompt
 test -e $KEYSTORE
 copy_apks_into_repo $REPOROOT
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 grep -F '<application id=' repo/index.xml > /dev/null
 test -e repo/index.xml
@@ -287,7 +334,7 @@ cd $REPOROOT
 mkdir repo
 copy_apks_into_repo $REPOROOT
 $fdroid init
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 grep -F '<application id=' repo/index.xml > /dev/null
 
@@ -301,7 +348,7 @@ cd $REPOROOT
 $fdroid init --keystore $KEYSTORE
 test -e $KEYSTORE
 copy_apks_into_repo $REPOROOT
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 test -e repo/index.xml
 test -e repo/index.jar
@@ -329,7 +376,7 @@ set -e
 $fdroid update --create-key
 test -e $KEYSTORE
 copy_apks_into_repo $REPOROOT
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 test -e repo/index.xml
 test -e repo/index.jar
@@ -345,14 +392,14 @@ cd $REPOROOT
 $fdroid init --keystore $KEYSTORE
 test -e $KEYSTORE
 copy_apks_into_repo $REPOROOT
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 test -e repo/index.xml
 test -e repo/index.jar
 grep -F '<application id=' repo/index.xml > /dev/null
 test -e $REPOROOT/repo/info.guardianproject.urzip_100.apk || \
     cp $WORKSPACE/tests/urzip.apk $REPOROOT/repo/
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 test -e repo/index.xml
 test -e repo/index.jar
@@ -361,7 +408,6 @@ grep -F '<application id=' repo/index.xml > /dev/null
 
 #------------------------------------------------------------------------------#
 echo_header "setup a new repo from scratch with a HSM/smartcard"
-
 REPOROOT=`create_test_dir`
 cd $REPOROOT
 $fdroid init --keystore NONE
@@ -380,7 +426,7 @@ touch fdroid-icon.png
 mkdir repo
 cp $WORKSPACE/tests/urzip.apk $REPOROOT/repo/
 set +e
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 if [ $? -eq 0 ]; then
     echo "This should have failed because this repo has no keystore!"
     exit 1
@@ -396,7 +442,7 @@ echo 'repo_keyalias = "foo"' >> config.py
 echo 'keystorepass = "foo"' >> config.py
 echo 'keypass = "foo"' >> config.py
 set +e
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 if [ $? -eq 0 ]; then
     echo "This should have failed because this repo has a bad/fake keystore!"
     exit 1
@@ -415,7 +461,7 @@ cd $REPOROOT
 $fdroid init --keystore $KEYSTORE
 test -e $KEYSTORE
 cp $WORKSPACE/tests/urzip.apk $REPOROOT/repo/
-$fdroid update --create-metadata
+$fdroid update --create-metadata --verbose
 $fdroid readmeta
 test -e repo/index.xml
 test -e repo/index.jar